<script lang="ts" setup>
import { useEmployeeStore } from "@/stores/employee";
import { ref } from "vue";
import type { VForm } from "vuetify/components";

const form = ref<VForm | null>(null);
const employeeStore = useEmployeeStore();

async function save() {
  const { valid } = await form.value!.validate();
  if (valid) {
    await employeeStore.saveEmployee();
  }
}
</script>

<template>
  <v-dialog v-model="employeeStore.dialog" persistent width="1024">
    <v-card>
      <v-card-title>
        <span class="text-h5">Employee</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="form">
          <v-container>
            <v-row>
              <v-col cols="12">
                <v-text-field
                  label="Name*"
                  required
                  v-model="employeeStore.editedEmployee.name"
                  :rules="[
                    (v) => !!v || 'Item is required.',
                    (v) => v.length > 4 || 'Length must more than 4.',
                  ]"
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  label="Role*"
                  required
                  v-model="employeeStore.editedEmployee.role"
                  :rules="[(v) => !!v || 'Item is required']"
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  label="Phone*"
                  required
                  v-model="employeeStore.editedEmployee.phone"
                  :rules="[
                    (v) => !!v || 'Item is required.',
                    (v) => v.length == 10 || 'Length must equal with 10.',
                  ]"
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  label="Salary*"
                  required
                  v-model.number="employeeStore.editedEmployee.salary"
                  :rules="[(v) => !!v || 'Item is required']"
                ></v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
        <small>*indicates required field</small>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn
          color="blue-darken-1"
          variant="text"
          @click="employeeStore.dialog = false"
        >
          Close
        </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="save"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <v-dialog v-model="employeeStore.delDialig" persistent width="auto">
    <v-card>
      <v-card-title>
        <span class="text-h5">Delete?</span>
      </v-card-title>
      <v-card-text> Are you sure want to delete this product? </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn
          color="blue-darken-1"
          variant="text"
          @click="employeeStore.delDialig = false"
        >
          No
        </v-btn>
        <v-btn
          color="blue-darken-1"
          variant="text"
          @click="employeeStore.deleteEmployee()"
        >
          Yes
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
